#include "PanelView.h"

//BRect frame, const char *name, uint32 resizingMode, uint32 flags

CPanelView::CPanelView(BRect r, const char* name, uint32 mode, uint32 flags, bool raised)
	: BView(r, name, mode, flags)
{
	mIsRaised = raised;
}

void CPanelView::Draw(BRect r)
{
	BeginLineArray(4);
	if(mIsRaised)
		SetHighColor(mHighColor);
	else
		SetHighColor(mLowColor);
	MovePenTo(Bounds().right, 0);
	StrokeLine(BPoint(0,0));
	StrokeLine(BPoint(0,Bounds().bottom));

	if(mIsRaised)
		SetHighColor(mLowColor);
	else
		SetHighColor(mHighColor);
	StrokeLine(BPoint(Bounds().right, Bounds().bottom));
	StrokeLine(BPoint(Bounds().right, 0));
	EndLineArray();
}

void CPanelView::SetViewColor(rgb_color col)
{
	uchar t;	

	BView::SetViewColor(col);
	SetLowColor(col);
	
	col.red <= 0x33 ? t = 0 : t = col.red - 0x33; 
	mLowColor.red = t;
	col.green <= 0x33 ? t = 0 : t = col.green - 0x33; 
	mLowColor.green = t;
	col.blue <= 0x33 ? t = 0 : t = col.blue - 0x33; 
	mLowColor.blue = t;
	
	col.red >= 0xdd ? t = 0xff : t = col.red + 0x22; 
	mHighColor.red = t;
	col.green >= 0xdd ? t = 0xff : t = col.green + 0x22; 
	mHighColor.green = t;
	col.blue >= 0xdd ? t = 0xff : t = col.blue + 0x22; 
	mHighColor.blue = t;
}

rgb_color CPanelView::GetHighColor()
{
	return mHighColor;
}

rgb_color CPanelView::GetLowColor()
{
	return mLowColor;
}


void CPanelView::AttachedToWindow(void)
{
	if(Parent())
		SetViewColor(Parent()->ViewColor());
	else
		SetViewColor(0xde,0xdb,0xde);
}
